restart
add wave CLK    
add wave CD
add wave Enable_RX  
add wave Serial_in  

add wave RX_OUT  
add wave New_Data  
add wave Error  

run  32 ns            

-- ( 9600 b/s x 8 = 76.8 kHz)
-- Start the receiver CLK of a 76800 kHz frequency (13.021 us period and 50% duty cycle) 
force CLK 0 0, 1 6.5 us -repeat 13.021 us

-- Set other input signals to an non-active level 
run  222 us
force CD 0
force Enable_RX 0
force Serial_in  1 
run  56.23 us

-- Let's apply a Clear Direct  

force CD 1
run  24.6 us
force CD 0
run  55.6 us

-- Let's enable the receiver  
force Enable_RX  1
run  24.6 us   

-- Let's simulate a given Serial_in data, for example (A3)h = "10100011"
-- Transmitter clock is 9600 Hz, so any received bit stay for a time of 104.17 us 

-- Start bit
force Serial_in  0 
run  104.17 us
 
-- D0
force Serial_in  1
run  104.17 us

-- D1
force Serial_in  1 
run  104.17 us

-- D2
force Serial_in  0 
run  104.17 us

-- D3
force Serial_in  0 
run  104.17 us

-- D4
force Serial_in  0 
run  104.17 us
     
-- D5
force Serial_in  1 
run  104.17 us

-- D6
force Serial_in  0 
run  104.17 us

-- D7
force Serial_in  1 
run  104.17 us
     
-- EPB
force Serial_in  0 
run  104.17 us
      
-- Stop bit 
force Serial_in  1 
run  104.17 us

-- run for an arbitrary time while waiting new data ....
run 341.56 us


-- Another data , for example (74)h = "01110100"

-- Start bit
force Serial_in  0 
run  104.17 us
 
-- D0
force Serial_in  0
run  104.17 us

-- D1
force Serial_in  0 
run  104.17 us

-- D2
force Serial_in  1 
run  104.17 us

-- D3
force Serial_in  0 
run  104.17 us

-- D4
force Serial_in  1 
run  104.17 us
     
-- D5
force Serial_in  1 
run  104.17 us

-- D6
force Serial_in  1 
run  104.17 us

-- D7
force Serial_in  0 
run  104.17 us
     
-- EPB
force Serial_in  0 
run  104.17 us
      
-- Stop bit 
force Serial_in  1 
run  104.17 us

            
run 300.23 us


-- run for an arbitrary time while waiting new data ....
run 451.56 us


-- Another data , for example (BC)h = "10111100"

-- Start bit
force Serial_in  0 
run  104.17 us
 
-- D0
force Serial_in  0
run  104.17 us

-- D1
force Serial_in  0 
run  104.17 us

-- D2
force Serial_in  1 
run  104.17 us

-- D3
force Serial_in  1 
run  104.17 us

-- D4      ---> let simulate an error in one bit (so the data was (BC)h, but the receiver got (AC)h      
			-- A parity error has to be detected here .... and the data will not be decoded
force Serial_in  0 
run  104.17 us
     
-- D5
force Serial_in  1 
run  104.17 us

-- D6    
force Serial_in  0 
run  104.17 us

-- D7
force Serial_in  1 
run  104.17 us
     
-- EPB
force Serial_in  1 
run  104.17 us
      
-- Stop bit 
force Serial_in  1 
run  104.17 us

            
run 458.34 us


-- Now the data is received rightly (BC)h = "10111100"

-- Start bit
force Serial_in  0 
run  104.17 us
 
-- D0
force Serial_in  0
run  104.17 us

-- D1
force Serial_in  0 
run  104.17 us

-- D2
force Serial_in  1 
run  104.17 us

-- D3
force Serial_in  1 
run  104.17 us

-- D4      
force Serial_in  1 
run  104.17 us
     
-- D5
force Serial_in  1 
run  104.17 us

-- D6    
force Serial_in  0 
run  104.17 us

-- D7
force Serial_in  1 
run  104.17 us
     
-- EPB
force Serial_in  1 
run  104.17 us
      
-- Stop bit 
force Serial_in  1 
run  104.17 us

            
run 458.34 us